package com.cirmuller.maidaddition.threads;

package .tmp;

import com.cirmuller.maidaddition.datagen.AIData;
import com.cirmuller.maidaddition.datagen.TaskKey;
import com.github.tartaricacid.touhoulittlemaid.api.task.IMaidTask;
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid;
import com.github.tartaricacid.touhoulittlemaid.entity.task.TaskManager;
import com.google.gson.Gson;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.Type;
import java.nio.charset.StandardCharsets;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Pattern;
import net.minecraft.data.PackOutput;
import net.minecraft.resources.ResourceLocation;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

@Deprecated
public class CalculateTaskThread extends Thread {
  private EntityMaid maid;
  
  private String message;
  
  private static Logger logger = LogManager.getLogger("maidaddition");
  
  private static String AISite = String.format(".%sconfig%s%s%sai.json", new Object[] { File.separator, File.separator, "maidaddition", File.separator });
  
  private static List<TaskKey> listOfTask = new ArrayList<>();
  
  public static void init() {
    File file = new File(AISite);
    if (!file.exists())
      try {
        file.getParentFile().mkdirs();
        file.createNewFile();
        OutputStream ostream = new FileOutputStream(file);
        AIData aiData = new AIData(new PackOutput(Path.of(AISite, new String[0])));
        String json = aiData.getJsonString();
        ostream.write(json.getBytes(StandardCharsets.UTF_8));
        ostream.close();
      } catch (IOException e) {
        e.printStackTrace();
      }  
    try {
      InputStream istream = new FileInputStream(file);
      String json = new String(istream.readAllBytes(), StandardCharsets.UTF_8);
      Gson gson = new Gson();
      Type listType = (new Object()).getType();
      listOfTask = gson.<List<TaskKey>>fromJson(json, listType);
      istream.close();
    } catch (FileNotFoundException e) {
      e.printStackTrace();
    } catch (IOException e) {
      e.printStackTrace();
    } 
    logger.info("AIData output dir: " + file.getPath());
  }
  
  public CalculateTaskThread(EntityMaid maid, String message) {
    this.maid = maid;
    this.message = message;
  }
  
  public void run() {
    IMaidTask task = calculateTask();
    synchronized (this.maid) {
      if (task != null) {
        this.maid.setTask(task);
        logger.info(String.format("Successfully set maid%d's task!", new Object[] { Integer.valueOf(this.maid.m_19879_()) }));
      } 
    } 
  }
  
  private IMaidTask calculateTask() {
    Map<TaskKey, Float> taskKeysWithScore = new HashMap<>();
    listOfTask.forEach(taskKey -> {
          float[] score = { 0.0F };
          taskKey.getMatchString().forEach(());
          taskKeysWithScore.put(taskKey, Float.valueOf(score[0]));
        });
    TaskKey highestScore = taskKeysWithScore.keySet().stream().sorted((a, b) -> ((((Float)taskKeysWithScore.get(a)).floatValue() - ((Float)taskKeysWithScore.get(b)).floatValue()) < -0.05D) ? 1 : (((((Float)taskKeysWithScore.get(a)).floatValue() - ((Float)taskKeysWithScore.get(b)).floatValue()) > 0.05D) ? -1 : 0)).toList().get(0);
    if (((Float)taskKeysWithScore.get(highestScore)).floatValue() > 0.2D) {
      IMaidTask result;
      if ((result = TaskManager.findTask(new ResourceLocation("touhou_little_maid", highestScore.getTask())).orElse(null)) != null)
        return result; 
      if ((result = TaskManager.findTask(new ResourceLocation("maidaddition", highestScore.getTask())).orElse(null)) != null)
        return result; 
      return null;
    } 
    return null;
  }
}
